"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const React = tslib_1.__importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_fast_image_1 = tslib_1.__importDefault(require("react-native-fast-image"));
const AnimatedFastImage = react_native_1.Animated.createAnimatedComponent(react_native_fast_image_1.default);
/**
 * ? Local Imports
 */
const ProgressiveFastImage_style_1 = tslib_1.__importDefault(require("./ProgressiveFastImage.style"));
class ProgressiveImage extends React.Component {
    constructor() {
        super(...arguments);
        this.animatedImage = new react_native_1.Animated.Value(0);
        this.animatedThumbnailImage = new react_native_1.Animated.Value(0);
        this.onThumbnailLoad = () => {
            react_native_1.Animated.timing(this.animatedThumbnailImage, {
                toValue: 1,
                useNativeDriver: this.props.useNativeDriver || true,
            }).start();
        };
        this.onImageLoad = () => {
            react_native_1.Animated.timing(this.animatedImage, {
                toValue: 1,
                useNativeDriver: this.props.useNativeDriver || true,
            }).start();
        };
    }
    render() {
        const { thumbnailSource, source, style, ...props } = this.props;
        return (<react_native_1.View style={ProgressiveFastImage_style_1.default.container}>
        <react_native_1.Animated.Image {...props} blurRadius={1} source={thumbnailSource} onLoad={this.onThumbnailLoad} style={[{ opacity: this.animatedThumbnailImage }, style]}/>
        <AnimatedFastImage {...props} source={source} onLoad={this.onImageLoad} style={[ProgressiveFastImage_style_1.default.imageStyle, { opacity: this.animatedImage }, style]}/>
      </react_native_1.View>);
    }
}
ProgressiveImage.defaultProps = {
    useNativeDriver: true,
};
exports.default = ProgressiveImage;
